# Contributing

## Versioning

This repository follows _Semantic Versioning 2.0.0_ specification.

## Analyzer, Formatter, etc.

Please do not modify `.gitignore`, `analysis_options.yaml`, and such files. Use
the current settings. Open an issue if you feel these files need to be updated.

## Coding Style

- Contributors must avoid writing "spaghetti code".
- Contributors should write comprehensive, readable, performant code.
- Contributors, if needed, should read the codebase to get an understanding of
  its coding style.

## Commit Messages

Contributors must follow _Conventional Commits 1.0.0_ specification for their
commit messages.

## Pull Requests

- Contributors must avoid adding pull requests that have no prior discussion
  with a positive feedback in a separate issue.
- There is no guarantee that all pull requests meeting the contribution
  guidelines will be approved and merged.
